/**
 * This code executes a recursive Fibonacci
 * This is intended to be parallelized with threads and tasks.
 * Mexico 2018
 * Jimmy Aguilar Mena
 */

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

#include <sys/types.h>
#include <sys/time.h>

//! Time measure
double mtime()
{
	struct timeval tmp;
	gettimeofday( &tmp, (struct timezone *)0 );
	return tmp.tv_sec + ((double)tmp.tv_usec)/1000000.0;
}

//! Serial Fibonacci recursive version
long fib(int n)
{
	if (n < 2)
		return n;
	return fib(n-1) + fib(n-2);
}

int main(int argc, char **argv)
{
	// Check command line arguments
	if (argc < 2){
		printf("Usage: %s order\n",  argv[0]);
		return -1;
	}
	int n = atoi(argv[1]);
	double t;

	t = mtime();
	long result = fib(n);
	t = mtime() - t;

	printf("Fibonacci(%d) = %ld in t = %lf sec\n", n, result, t);
	return 0;
}

